#ifndef INCLUDED_luxe_utils_json_JSONEncoder
#define INCLUDED_luxe_utils_json_JSONEncoder

#ifndef HXCPP_H
#include <hxcpp.h>
#endif

HX_DECLARE_CLASS0(IMap)
HX_DECLARE_CLASS2(haxe,ds,StringMap)
HX_DECLARE_CLASS3(luxe,utils,json,JSONEncoder)
namespace luxe{
namespace utils{
namespace json{


class HXCPP_CLASS_ATTRIBUTES  JSONEncoder_obj : public hx::Object{
	public:
		typedef hx::Object super;
		typedef JSONEncoder_obj OBJ_;
		JSONEncoder_obj();
		Void __construct(Dynamic value);

	public:
		inline void *operator new( size_t inSize, bool inContainer=true)
			{ return hx::Object::operator new(inSize,inContainer); }
		static hx::ObjectPtr< JSONEncoder_obj > __new(Dynamic value);
		static Dynamic __CreateEmpty();
		static Dynamic __Create(hx::DynamicArray inArgs);
		//~JSONEncoder_obj();

		HX_DO_RTTI;
		static void __boot();
		static void __register();
		void __Mark(HX_MARK_PARAMS);
		void __Visit(HX_VISIT_PARAMS);
		::String __ToString() const { return HX_CSTRING("JSONEncoder"); }

		::String jsonString;
		virtual ::String getString( );
		Dynamic getString_dyn();

		bool debug;
		virtual Void _trace( ::String e);
		Dynamic _trace_dyn();

		virtual ::String convertToString( Dynamic value);
		Dynamic convertToString_dyn();

		virtual Dynamic mapHash( ::haxe::ds::StringMap value);
		Dynamic mapHash_dyn();

		virtual ::String escapeString( ::String str);
		Dynamic escapeString_dyn();

		virtual ::String arrayToString( Dynamic a);
		Dynamic arrayToString_dyn();

		virtual ::String objectToString( Dynamic o);
		Dynamic objectToString_dyn();

		virtual ::String instanceToString( Dynamic o,::Class cls);
		Dynamic instanceToString_dyn();

};

} // end namespace luxe
} // end namespace utils
} // end namespace json

#endif /* INCLUDED_luxe_utils_json_JSONEncoder */ 
